/*
 * Copyright (C) 2006  Emmanuel VARAGNAT <>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "array.h"

int array_init(struct array *array, size_t type_size, size_t size) {
  array->data = malloc(type_size * size);
  if(array->data == NULL)
    return 1;

  array->size = size;
  array->type_size = type_size;
  array->last = 0;
  return 0;
}

void array_append(struct array *array, void *item) {
  assert(array->last < array->size);

  memcpy(array->data + (array->last * array->type_size),
	 item,
	 array->type_size);
  array->last++;
}
